# SPEC file for packages est2ed libest2 and libest2-devel
# Usage: rpmbuild -bb est2ed.spec
#
# You may have to create/change your ~/.rpmmacros
# http://rpm5.org/docs/api/macros.html
#
# Here is my ~/.rpmmacros which has only a single line:
# %_topdir        /home/meolic/est2ed/rpm
#
# This file has been constructed using the following examples:
#
# http://www.rpm-based.org/how-to-create-rpm-package
# http://www.rpm.org/max-rpm/
# http://kmymoney2.sourceforge.net/phb/rpm-example.html
# http://dries.ulyssis.org/apt/packages/gnunet/gnunet-spec.html
#

Name: est2ed
Requires: libbiddy1
Summary: Efficient Symbolic Tools 2nd Edition
Group: Education
Version: THISVERSION
Release: THISRELEASE
License: GPL
URL: http://lms.uni-mb.si/EST/
Source: est2ed-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}
Packager: meolic

%description
EST is a tool for the formal verification of systems.

 EST is a collection of symbolic algorithms based on binary decision diagrams (BDDs).
Curently, it supports only our own BDD package called Biddy, but one day it could
support other BDD packages, too.

 EST provides libraries of functions, which you can use in your own main program.

 This package includes simple Tcl/Tk GUI called My Interface, from which you can access
all the features.

http://lms.uni-mb.si/EST/

%prep
echo "Preparing %{name}-%{version}-%{release}"
%setup -q
echo "Sources OK. Let's go building!"

%build
%{__make} mish "BINDIR=`pwd`/bin"
%{__make} milocal "BINDIR=`pwd`/bin"

%define _sharedir %{_prefix}/share

%install
%{__rm} -fr %{buildroot}
%{__make} -f Makefile.Linux DESTDIR=%{buildroot}/usr install "BINDIR=`pwd`/bin"

%clean
%{__rm} -fr %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc VERSION CHANGES
%{_bindir}/
%{_libdir}/
%{_sharedir}/

%changelog
